#include <bits/stdc++.h>
#define ll long long
using namespace std;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll t;
    cin >> t;
    while(t--)
    {
        ll n,m;
        cin >> n >> m;
        ll a[n+1][m+1],red[n+1],kolona[m+1],b[n+1][m+1];
        for(ll i=1;i<=n;i++) red[i]=0;
        for(ll i=1;i<=m;i++) kolona[i]=0;
        for(ll i=1;i<=n;i++)
        {
            for(ll j=1;j<=m;j++)
            {
                cin >> a[i][j];
                red[i]=max(red[i],a[i][j]);
            }
        }
        for(ll i=1;i<=n;i++)
        {
            for(ll j=1;j<=m;j++)
            {
                cin >> b[i][j];
            }
        }
        for(ll i=1;i<=m;i++)
        {
            for(ll j=1;j<=n;j++)
            {
                kolona[j]=min(kolona[i],a[j][i]-red[j]);
            }
        }
        bool p=1;
        for(ll i=1;i<=n;i++)
        {
            for(ll j=1;j<=m;j++)
            {
                if(red[i]+kolona[j]!=a[i][j]) p=0;
            }
        }
        if(p)
        {
            cout << "DA\n";
            for(ll i=1;i<=n;i++)
            {
                for(ll j=1;j<=m;j++)
                {
                    cout << a[i][j] << " ";
                }
                cout << endl;
            }
        }
        else cout << "NE\n";
    }
    return 0;
}